class GridScrollbar(parentObj) of CONTAINER(parentObj) custom
   with (this)
      onOpen = class::CONTAINER_ONOPEN
      onDesignOpen = class::CONTAINER_ONDESIGNOPEN
      left = 3
      top = 4
      width = 432
      height = 244
      metric = 6	// Pixels
      borderStyle = 2	// Lowered
   endwith

   this.GRID1 = new GRID(this)
   with (this.GRID1)
      onLeftMouseDown = class::GRID1_ONLEFTMOUSEDOWN
      bgColor = "white"
      cellHeight = 19
      hasIndicator = false
      hasColumnHeadings = false
      hasVScrollHintText = false
      rowSelect = true
      hScrollBar = 0	// Off
      vScrollBar = 0	// Off
      pageno = 0
      height = 244
      left = -1
      top = 0
      width = 433
   endwith

   this.VerticalScrollbar = new SCROLLBAR(this)
   with (this.VerticalScrollbar)
      onChange = class::VerticalScrollbar_ONCHANGE
      onOpen = class::VerticalScrollbar_ONOPEN
      onLeftMouseUp = class::VerticalScrollbar_ONLEFTMOUSEUP
      height = 241
      left = 413
      top = 2
      width = 18
      value = 1
      rangeMin = 1
      rangeMax = 100
      pageno = 0
   endwith

   Function Container_onDesignOpen
      this.parent.metric=6
      this.borderstyle=2
      // the following lines to fill the container (or eventually the  custom class object)
      // if it was resized in the Form designer or lowered by a menu
      this.GRID1.top := 0
      this.GRID1.left := - 1
      this.GRID1.height := this.height
      this.GRID1.width := this.width + 1
      this.VerticalScrollbar.top := 2
      this.VerticalScrollbar.left := this.width - 19
      this.VerticalScrollbar.height := this.height - 3
      this.VerticalScrollbar.width = 18
      return

   Function Container_onOpen
      // the following lines to fill the container (or eventually the  custom class object)
      // if it was resized in the Form designer or lowered by a menu
      this.borderstyle = 3  // none
      this.GRID1.top := 0
      this.GRID1.left := - 1
      this.GRID1.height := this.height
      this.GRID1.width := this.width + 1
      //  we will calculate the number of pixels over the ones that display the data
      this.GRID1.nondataPixels = iif(this.GRID1.hasColumnHeadings = true, this.Grid1.cellHeight+1, 0)

      local r
      r = this.GRID1.datalink
      r.first()
      r.bookmark1 = r.bookmark()  // custom property
      r.canNavigate = { ; this.bookmark1 = this.bookmark() }
      this.nRowsNavigated = 0  // custom property
      return

   Function VerticalScrollbar_onChange
      if this.active = true
         local r, n
         r = this.parent.GRID1.datalink
         n = this.value - this.oldValue
         r.next(n)
         this.oldValue = this.value
      endif
      return

   Function VerticalScrollbar_onOpen
      // the following lines to fill the container (or eventually the custom class object)
      // if it was resized in the Form designer or lowered by a menu
      this.top := 2
      this.left := this.parent.width - 19
      this.height := this.parent.height - 3
      this.width = 18
      this.active = true    // custom property
      this.oldValue = 1     // custom property
      this.rangeMax = this.parent.GRID1.datalink.count()
      return

   Function VerticalScrollbar_onLeftMouseUp(flags, col, row)
      if this.height > 3*16 // otherwise there's no room for the shaft
         local g, n
         g = this.parent.GRID1
         // at the end of the following line, we substract one row (already navigated in the onChange code)
         n = floor((g.height - g.nondataPixels)/(g.cellHeight + g.gridLineWidth)) - 1
         do case
            case row > 16 and row < round(((this.height-48)*(this.value/this.rangeMax)),0) + 16
               if this.value > 1
                  this.active = false  //  to avoid eternal loop
                  g.datalink.onNavigate = null
                  if this.value * (g.cellHeight + g.gridLineWidth) < (g.height - g.nondataPixels)
                     g.datalink.first()
                     this.value = 1
                  else
                     g.datalink.next(-n)
                     this.value -= n
                  endif
                  this.oldValue = this.value
                  g.datalink.canNavigate = { ; this.bookmark1 = this.bookmark() }
                  this.active = true
               else
                  msgBox("You're already at the first record"," Impossible to navigate")
                  g.setFocus()
               endif
            case row < this.height-16 and row > round(((this.height-48)*(this.value/this.rangeMax)),0) + 32
               if this.value < this.rangeMax
                  this.active = false  //  to avoid eternal loop
                  g.datalink.onNavigate = null
                  if (this.rangeMax - this.value)*(g.cellHeight + g.gridLineWidth) < (g.height - g.nondataPixels)
                     g.datalink.last()
                     this.value = this.rangeMax
                  else
                     // at the end of the following line, we take out one row (already navigated in the onChange code
                     n = floor((g.height - g.nondataPixels)/(g.cellHeight + g.gridLineWidth)) - 1
                     g.datalink.next(n+1)  // to correct a display bug
                     g.datalink.next(-1)
                     this.value += n
                  endif
                  this.oldValue = this.value
                  g.datalink.canNavigate = { ; this.bookmark1 = this.bookmark() }
                  this.active = true
               else
                  msgBox("You're already at the last record"," Impossible to navigate")
                  g.setFocus()
               endif
         endcase
      endif
      return

   Function GRID1_onLeftMouseDown(flags, col, row)
      local r, aRowCopy, nRowsNavigated, nRowsDisplayed, nIdenticalValues, hasNavigated, vsb, cellBorderWidth
      r = this.datalink
      r.notifyControls := false  // to hide navigation to the user
      r.canNavigate = null       // to avoid bookmarking each time we navigate
      vsb = this.parent.VerticalScrollbar
      // new code to take into account mouse scrolling (new in dBASE PLUS 2.6)
      if val(version().substring(11,14)) > 2.5
         r.bookmark1 = r.bookmark()
         r.last()
         nRowsNavigated = vsb.rangeMax - vsb.value
         r.bookmark2 = r.bookmark()
         // we will find a row identical with the one that we have bookmarked
         do while NOT r.bookmarksEqual(r.bookmark1, r.bookmark2)
            r.next( - 1)  // we go back one row
            r.bookmark2 = r.bookmark()
            nRowsNavigated --
         enddo
      else
         // we tag the row that was clicked
         r.bookmark2 = r.bookmark()
         r.goto(r.bookmark1)  // we move back to the row that was current before clicking
         nRowsNavigated = 0
         /*
         since we don't know if the clicked item in the grid was over or below the item
         that was highlighted, we will move one full screen further in the rowset and
         search back from there
         */
         nRowsDisplayed = Ceiling((this.height - this.nondataPixels)/(this.cellHeight + this.gridLineWidth))
         // since we don't know how far we are from the bottom of the rowset 
         // we won't try to jump one "screenful", but rather one row at the time
         // until we reach the theoretical number of rows displayed in the grid.
         for i = 1 to nRowsDisplayed  // we will try to navigate further
            hasNavigated = r.next( 1 )
            if hasNavigated = true  // if we succeed navigating
               nRowsNavigated ++    // we increment the value of that variable
            else  // if end of file
               r.last( )  // go back to the last row
               i = nRowsDisplayed  // to quit the for/next loop
            endif
         next
         // we will find a row identical with the one that we have bookmarked
         r.bookmark1 = r.bookmark()
         do while NOT r.bookmarksEqual(r.bookmark1, r.bookmark2)
            r.next( - 1)  // we go back one row
            r.bookmark1 = r.bookmark()
            nRowsNavigated --
         enddo
      endif
      r.bookmark1 = r.bookmark()  // to correct a bug when the user clicks the same row
      r.canNavigate = { ; this.bookmark1 = this.bookmark() }
      this.datalink.notifyControls := true
      // we will update the value of the vertical Scrollbar
      vsb.active = false  // to avoid eternal loop
      vsb.value += nRowsNavigated
      vsb.oldValue = vsb.value
      vsb.active = true
      return

endclass
